'****************************************************************************************
' 2x_COM_0.bas                                                                     6.9.09
'****************************************************************************************

$regfile = "m8def.dat"
$crystal = 8000000
$baud = 9600

'********************** Aufgabe des Programms *******************************************
' D_aus - 1 = W_ein (W_ein = D_aus -1)
' W_aus + 1 = D_ein (D_ein = W_aus +1)

Dim W_aus As Byte                                 ' byte vom RS232/I2C Wandler asc(0) = NUL
Dim W_ein As Byte                                 ' byte zum RS232/I2C Wandler asc(0) = NUL

Dim D_aus As Byte                                 ' byte vom D-STAR asc(0) = 1
Dim D_ein As Byte                                 ' byte zum D-STAR asc(0) = 1

'*******************************************************************************************
'$sim
Osccal = &Hbc

Waitms 100

Open "comd.6:9600,8,n,1" For Input As #1
Open "comd.7:9600,8,n,1" For Output As #2


Do

   D_aus = Inkey(#1)                              ' D-STAR>Wandler SW-UART erlaubt chr(0) nicht
      If D_aus <> 0 Then                          ' Zeichen im Puffer...
      W_ein = Asc(d_aus) - 1                      ' in ASCII wandeln... (wg. -1)
      Print Chr(w_ein);                           ' ausgeben ber HW-UART
   End If

   W_aus = Ischarwaiting()                        ' Wandler>D-STAR HW-UART erlaubt chr(0)
   If W_aus = 1 Then                              ' Zeichen im HW-Puffer...
      W_aus = Inkey()                             ' ... einlesen
      If W_aus <> 255 Then
                                                  ' ###############################################################
         D_ein = Asc(w_aus) + 1                   ' in ASCII wandeln...  (wg. +1) ABER NICHT "FF", sonst wieder "0"
                                                  ' ###############################################################
      End If
      Print #2 , Chr(d_ein);                      ' ausgeben ber SW-UART
   End If

Loop

Close #1                                          'Close the channels
Close #2

End